export default {
  none:0,
  /// <ummary>
  /// 大于
  /// </summary>
  greaterthan : 1,
  gt :1,
  /// <summary>
  /// 大于等于
  /// </summary>
  greaterthanorequal : 2,
  gte: 2,
  /// <summary>
  /// 小于
  /// </summary>
  lessthan : 3,
  lt: 3,

  /// <summary>
  /// 小于等于
  /// </summary>
  lessthanorequal: 4,
  lte: 4,

  /// <summary>
  /// 包含（仅限字符串类型使用）
  /// </summary>

  contains: 5,
  like: 5,


  /// <summary>
  /// 以给定参数开始（仅限字符串类型使用）
  /// </summary>
  startwith: 6,
  slike :6,


  /// <summary>
  /// 以给定参数结尾（仅限字符串类型使用）
  /// </summary>
  endwith: 7,
  elike: 7,
  /// <summary>
  /// In查询
  /// </summary>
  in :8,
  "@in" : 8,
  /// <summary>
  /// NotIn查询
  /// </summary>
  NotIn: 9,
  notin :9,
  /// <summary>
  /// 范围查询，给定的参数必须是两个值
  /// </summary>
  between : 10,
  /// <summary>
  /// 等于
  /// </summary>
  equals : 11,
  eq :11,
  /// <summary>
  /// 查询模式为自动（字符串应用like,数字应用eq,时间应用为gte,枚举应用为in,其他的应用eq)
  /// </summary>
  auto : Number.MAX_VALUE

}
