export default {

  //
  // 摘要:
  //     整型，表示签名值介于-9223372036854775808 到 9223372036854775807 之间的 64 位整数。
  int: 11,
  //
  // 摘要:
  //     浮点型，表示从大约 5.0 x 10 范围内的值-324到 1.7 x 10 308与 15-16 位数的精度。
  double: 14,
  //
  // 摘要:
  //     表示日期和时间值的类型。
  datetime: 16,
  /// <summary>
  /// 单行字符串输入
  /// </summary>
  string: 18,
  /// <summary>
  /// 文本域，与String不同的是文本域可以支持多行输入
  /// </summary>
  text: 19,
  //
  // 摘要:
  //     表示至显示日期的类型。
  date: 34,
  /// <summary>
  /// 枚举
  /// </summary>
  enum: 225,
  /// <summary>
  /// IP或域名
  /// </summary>
  ip_or_domain: 226,

}
