//import Vue from 'vue';
//import VueAMap from 'vue-amap';
//Vue.use(VueAMap);
////地图插件引入，可以按需引入
//VueAMap.initAMapApiLoader({
//  key: 'ecd528345198c8dc6f5e399beabe9b42',
//  plugin: [
//    'AMap.Autocomplete',
//    'AMap.PlaceSearch',
//    'AMap.Scale',
//    'AMap.OverView',
//    'AMap.ToolBar',
//    'AMap.MapType',
//    'AMap.ControlBar',
//    'AMap.PolyEditor',
//    'AMap.CircleEditor',
//    //定位
//    'AMap.Geolocation',
//    //地理编码
//    'AMap.Geocoder',
//    //行政区查询
//    'AMap.DistrictSearch',
//    //自动驾车
//    'AMap.Driving',
//    //可拖拽
//    'AMap.DragRoute',
//    //鼠标工具插件
//    'AMap.MouseTool',
//    //测距
//    'AMap.RangingTool',
//    //点聚合
//    'MarkerClusterer',
//    //自定义图层
//    "AMap.CustomLayer",
//    //轨迹纠偏服务
//    "AMap.GraspRoad",
//    //热力图
//    "AMap.Heatmap",
//    //简易行政区图
//    "DistrictLayer"
//  ],
//  // 默认高德 sdk 版本为 1.4.4
//  v: '1.4.14',
//  uiVersion: '1.0.11'
//});
//import { lazyAMapApiLoaderInstance } from 'vue-amap';
//import core from '../core';
//import mapFunc from './map';

//const fillColor = "#1791fc"; //填充色 默认值"#1791fc"
//const fillOpacity = 0.35;//填充透明度 默认值0.35
//const strokeWeight = 2;//线宽 默认值2
//const strokeColor = "#1791fc";//线颜色 默认值"#1791fc"
//const strokeOpacity = 0.9;//线透明度 默认值0.9

//let obj = {
//  amap: {},
//  geocoder: null,
//  mousetool: null,
//  rangtool: {},
//  dragroute: null,
//  satellite: {},
//  roadNet: {},
//  traffic: {},
//  create(data) {
//    var $this = this;
//    lazyAMapApiLoaderInstance.load().then(() => {
//      this.district = new AMap.DistrictSearch({
//        // 返回行政区边界坐标等具体信息
//        extensions: 'all',
//        // 设置查询行政区级别为 区，
//      });
//      this.amap[data.id] = null;
//      let mapData = {
//        animateEnable: false,
//      }
//      if (data.mapStyle) mapData.mapStyle = data.mapStyle;
//      if (data.viewMode) mapData.viewMode = '3D';
//      if (data.pitch) mapData.pitch = data.pitch;
//      if (!data.pitchEnable) mapData.pitchEnable = false
//      if (!data.rotateEnable) mapData.rotateEnable = false;
//      if (data.mask && data.mask.keywords) {
//        let mapMask = [];
//        this.keywords = data.mask.keywords;
//        this.index = 0;
//        let keyMask = {};
//        this.drawMaskMap(mapMask, keyMask, this.keywords[0], (mask, keyMask) => {
//          mapData.mask = mask;
//          var retData = {
//            keyMask: keyMask,
//            mask: mask
//          }
//          this.initMapObj(data, mapData, retData);
//        });
//      } else {
//        this.initMapObj(data, mapData);
//      }
//    }).
//      catch((res) => {
//        throw new Error(res);
//      });
//  },
//  //地图初始化时需要执行的
//  initMapObj(data, mapData,area) {
//    this.amap[data.id] = new AMap.Map(data.id, mapData);
//    this.satellite[data.id] = new AMap.TileLayer.Satellite();
//    this.roadNet[data.id] = new AMap.TileLayer.RoadNet();
//    this.traffic[data.id] = new AMap.TileLayer.Traffic();
//    this.traffic[data.id].setMap(this.amap[data.id]);
//    this.roadNet[data.id].setMap(this.amap[data.id]);
//    this.satellite[data.id].setMap(this.amap[data.id]);
//    this.roadNet[data.id].hide();
//    this.traffic[data.id].hide();
//    this.satellite[data.id].hide();
//    //地图缩放监听
//    // 在图面添加比例尺控件，展示地图在当前层级和纬度下的比例尺
//    if (data.scale) {
//      this.amap[data.id].addControl(new AMap.Scale());
//    }
//    // 在图面添加鹰眼控件，在地图右下角显示地图的缩略图
//    if (data.overview) {
//      this.amap[data.id].addControl(new AMap.OverView());
//    }
//    // 在图面添加类别切换控件，实现默认图层与卫星图、实施交通图层之间切换的控制
//    if (data.toolbar) {
//      // 在图面添加工具条控件，工具条控件集成了缩放、平移、定位等功能按钮在内的组合控件
//      this.amap[data.id].addControl(new AMap.ToolBar({
//        offset: new AMap.Pixel(10, 60),
//      }));
//    }
//    if (data.maptype) {
//      this.amap[data.id].addControl(new AMap.MapType());
//    }
//    if (data.controlBar) {
//      this.amap[data.id].addControl(new AMap.ControlBar());
//    }
//    //地理编码
//    this.geocoder = new AMap.Geocoder();
//    this.rangtool[data.id] = new AMap.RangingTool(this.amap[data.id]);
//    this.mousetool = new AMap.MouseTool(this.amap[data.id]);

//    if (data.callback) {
//      data.callback(area)
//    }
//  },
//  drawMaskMap(mask, keyMask, key, callback) {
//    this.district.search(key, (status, info) => {
//      if (status == "complete") {
//        let bounds = info.districtList[0].boundaries;
//          keyMask[key] = bounds;
//         for (let j = 0; j < bounds.length; j++) {
//          mask.push([bounds[j]])
//        }
//      }
//      let next = this.keywords[this.index++];
//      if (next) {
//        this.drawMaskMap(mask, keyMask, next, callback);
//      } else {
//        if (callback) callback(mask, keyMask);
//      }
//    });
//  },
//  //设置地图风格
//  setMapStyle(style, id) {
//    var map = this.getMapObj({ id: id }).currentObj;
//    let styleStr = 'amap://styles/' + style;
//    map.setMapStyle(styleStr);
//  },
//  //设置俯仰角,3D视图有效
//  setPitch(Number, id) {
//    var map = this.getMapObj({ id: id }).currentObj;
//    map.setPitch(Number);
//  },
//  zoomIn(id) {
//    var map = this.getMapObj({ id: id }).currentObj;
//    map.zoomIn();
//  },
//  zoomOut(id) {
//    var map = this.getMapObj({ id: id }).currentObj;
//    map.zoomOut();
//  },
//  //卫星图层
//  satelliteShow(data) {
//    this.satellite[data.id].show();
//  },
//  //路网图层
//  roadNetShow(data) {
//    this.roadNet[data.id].show();
//  },
//  //路况图层
//  trafficShow(data) {
//    this.traffic[data.id].show();
//  },
//  //卫星图层
//  satelliteHide(data) {
//    this.satellite[data.id].hide();
//  },
//  //路网图层
//  roadNetHide(data) {
//    this.roadNet[data.id].hide();
//  },
//  //路况图层
//  trafficHide(data) {
//    this.traffic[data.id].hide();
//  },
//  //获取两点间距离
//  distance(data) {
//    var p = [];
//    for (var i = 0; i < data.length; i++) {
//      if (!data[i].lng || !data[i].lat) {
//        p.push(p);
//      } else {
//        p.push([data[i].lng, data[i].lat]);
//      }
//    }
//    var dis = AMap.GeometryUtil.distance(p[0], p[1]);
//    return dis;
//  },
//  //行政区查询实例
//  districtSearch(data) {
//    var inst = {};
 
//    var district = new AMap.DistrictSearch({
//      // 返回行政区边界坐标等具体信息
//      extensions: 'all',
//      // 设置查询行政区级别为 区 
//      level: data.level ? data.level : 'district',
//      subdistrict: data.subdistrict ? data.subdistrict : '1',
//      showbiz: data.showbiz!==undefined ? data.showbiz : true,
//    });
//    inst.obj = district;
//    inst.search = function (keywords, callback) {
//      inst.obj.search(keywords, (status, res) => {
//        var resInfo = {};
//        if (status == "complete") {
//          resInfo.Info = res.Info;
//          resInfo.districtList = res.districtList;
//        } else {
//          resInfo.Info = "";
//          resInfo.districtList = null;
//        }
//        callback(status, resInfo);
//      })
//    };
//    inst.setLevel = function (level) {
//      //设置关键字对应的行政区级别或商圈，可选值：
//      // country：国家
//      //province：省 / 直辖市
//      // city：市
//      //district：区 / 县
//      //biz_area：商圈
//      inst.obj.setLevel(level);
//    }
//    inst.setSubdistrict = function (district) {
//      //设置下级行政区级数（行政区级别包括：国家、省/直辖市、市、区/县4个级别），商圈为区/县下一级，默认值：1
//      //可选值：0、1、2、3
//      //0：不返回下级行政区；
//      //1：返回下一级行政区；
//      //2：返回下两级行政区；
//      //3：返回下三级行政区
//      inst.obj.setSubdistrict(district);
//    }
//    return inst;
//  },
//  //数组path处理
//  getPoints(data) {
//    var lnglat = [];
//    if (core.isNull(data.length) && data.currentObj) {
//      return [data.currentObj];
//    }
//    for (let i = 0; i < data.length; i++) {
//      if (Array.isArray(data[i])) {
//        lnglat.push(this.lngLat(data[i][0], data[i][1]).currentObj);
//      } else if (typeof (data[i]) == "object") {
//        if (data[i].currentObj) {
//          lnglat.push(data[i].currentObj);
//        } else {
//          lnglat.push(data[i]);
//        }
//      } else if (typeof (data[i]) != "object") {
//        lnglat = [this.lngLat(data[0], data[1]).currentObj];
//        break;
//      }
//    }
//    return lnglat;
//  },
//  setPoints(arr) {
//    var poi = []
//    for (var i = 0; i < arr.length; i++) {
//      poi.push({
//        currentObj: arr[i],
//        lng: arr[i].lng,
//        lat: arr[i].lat,
//      })
//    }
//    return poi;
//  },
//  convertFrom(gps, callback) {
//    AMap.convertFrom(gps, 'gps', function (status, result) {
//      if (result.info === 'ok') {
//        var lnglats = result.locations; // Array.<LngLat>
//        if (callback) {
//          callback()
//        }
//      }
//    });
//  },
//  getMapObj(data) {
//    var instance = null;
//    if (data && data.id !== undefined) {
//      instance = {
//        currentObj: this.amap[data.id]
//      };
//    } else {
//      instance = {
//        currentObj: this.amap["mapBox"]
//      };
//    }
//    instance.getSize = function () {
//      return instance.currentObj.getSize();
//    }
//    instance.getBounds = function () {
//      var bounds = instance.currentObj.getBounds();
//      var obj = {
//        currentObj: bounds,
//        northeast: bounds.northeast,
//        southwest: bounds.southwest
//      }
//      return obj;
//    }
//    instance.setBounds = function (bounds) {
//      var b = bounds.currentObj ? bounds.currentObj : bounds;
//      instance.currentObj.setBounds(b);
//    }
//    instance.lngLatToContainer = function (lnglat) {
//      var pos = null;
//      if (lnglat.currentObj) {
//        pos = instance.currentObj.lngLatToContainer(lnglat.currentObj);
//      } else {
//        pos = instance.currentObj.lngLatToContainer(lnglat);
//      }
//      return pos;
//    }
//    return instance;
//  },
//  //摧毁地图
//  destroy(id) {
//    var map = this.getMapObj({ id: id }).currentObj;
//    if (map) {
//      map.destroy();
//    }
//  },

//  clearMap(id) {
//    var map = this.getMapObj({ id: id }).currentObj;
//    map.clearMap();
//  },

//  add(data, id) {
//    if (data) {
//      var map = this.getMapObj({ id: id }).currentObj;
//      if (Array.isArray(data)) {
//        var arr = [];
//        for (var i = 0; i < data.length; i++) {
//          arr.push(data[i].currentObj);
//        }
//        map.add(arr);
//      } else {
//        map.add(data.currentObj);
//      }
//      //map.setFitView();
//    } else {
//      throw new Error("data is undefined");
//      return
//    }
//  },
//  //移除覆盖物数组
//  remove(arr, id) {
//    var overlay = [];
//    var data = { id: id };
//    var map = this.getMapObj(data).currentObj;
//    if (Array.isArray(arr)) {
//      for (var i = 0; i < arr.length; i++) {
//        if (arr[i].currentObj) {
//          overlay.push(arr[i].currentObj);
//        } else {
//          overlay.push(arr[i]);
//        }
//      }
//    } else {
//      if (arr.currentObj) {
//        overlay = arr.currentObj;
//      } else {
//        overlay = arr;
//      }
//    }
//    map.remove(overlay);
//  },

//  //设置中心城市
//  setCity(name, callback, id) {
//    var data = { id: id };
//    var map = this.getMapObj(data).currentObj;
//    map.setCity(name, () => {
//      if (callback) {
//        callback();
//      }
//    });
//  },

//  //设置中心点
//  zoomAndCenter(zoom, center, id) {
//    var data = { id: id };
//    var map = this.getMapObj(data).currentObj;
//    if (center.currentObj) {
//      map.setZoomAndCenter(zoom, center.currentObj);
//    } else {
//      map.setZoomAndCenter(zoom, center);
//    }
//  },
//  setZoom(num, id) {
//    var data = { id: id };
//    var map = this.getMapObj(data).currentObj;
//    map.setZoom(num);
//  },
//  setCenter(center, id) {
//    var data = { id: id };
//    var map = this.getMapObj(data).currentObj;
//    if (center.currentObj) {
//      map.setCenter(center.currentObj);
//    } else {
//      map.setCenter(center);
//    }
//  },
//  //正向地理编码
//  getLocation(address, callback) {
//    //address:String
//    this.geocoder.getLocation(address, function (status, res) {
//      if (callback) {
//        var data = {};
//        data["geocodes"] = [];
//        if (status == "complete") {
//          data["info"] = res.info;
//          data["resultNum"] = res.resultNum;
//          for (let i = 0; i < res.geocodes.length; i++) {
//            if (!res.geocodes[i]) {
//              data["geocodes"][i] = null;
//            } else {
//              data["geocodes"][i] = {};
//              data["geocodes"][i]["formattedAddress"] = res.geocodes[i].formattedAddress;
//              data["geocodes"][i]["adcode"] = res.geocodes[i].adcode;
//              data["geocodes"][i]["level"] = res.geocodes[i].level;
//              data["geocodes"][i]["location"] = res.geocodes[i].location;
//            }
//          }
//        } else if (status == "error") {
//          data["info"] = res;
//          data["resultNum"] = 0;
//        } else {
//          data["info"] = "检索结果为0";
//          data["resultNum"] = 0;
//        }
//        callback(status, data);
//      }
//    });
//  },
//  //获取地址 逆向地理编码
//  getAddress(lnglat, callback) {
//    var poi = lnglat.currentObj ? lnglat.currentObj : this.lngLat(lnglat[0], lnglat[1]).currentObj;
//    this.geocoder.getAddress(poi, function (status, res) {
//      if (callback) {
//        var data = {};
//        data["regeocode"] = {};
//        if (status == "complete") {
//          data["info"] = res.info;
//          data["regeocode"]['formattedAddress'] = res["regeocode"]['formattedAddress'];
//          data["regeocode"]["addressComponent"] = res["regeocode"]["addressComponent"];
//        } else if (status == "error") {
//          data["info"] = res;
//        } else {
//          data["info"] = "检索结果为0";
//        }
//        callback(status, data);
//      }
//    });
//  },

//  //获取地图中心
//  getCenter(id) {
//    var data = { id: id };
//    var map = this.getMapObj(data).currentObj;
//    return { currentObj: map.getCenter() };
//  },
//  //获取地图zoom
//  getZoom(id) {
//    var data = { id: id };
//    var map = this.getMapObj(data).currentObj;
//    return map.getZoom();
//  },
//  //创建坐标点
//  lngLat(lng, lat) {
//    let pnt = {};
//    var currentObj = new AMap.LngLat(lng, lat);
//    pnt.currentObj = currentObj;
//    pnt.lng = currentObj.lng;
//    pnt.lat = currentObj.lat;
//    return pnt;
//  },
//  newPixel(data) {
//    var pixel = {}
//    var currentObj = new AMap.Pixel(data.x, data.y);
//    pixel.currentObj = currentObj;
//    pixel.x = currentObj.x;
//    pixel.y = currentObj.y;
//    return pixel;
//  },

//  //创建mark
//  newMark(data) {
//    var $this = this;
//    var mark = {};
//    var currentObj = new AMap.Marker({
//      position: $this.lngLat(data.lng, data.lat).currentObj,
//      icon: data.icon ? data.icon : "",
//      content: data.content ? data.content : "",
//      offset: data.offset ? data.offset : $this.newPixel({ x: -10, y: -34 }).currentObj,
//      label: data.label ? data.label : {},
//      title: data.title ? data.title : "",
//      autoRotation: true,
//      angle: data.angle ? data.angle : 0,
//    });
//    mark.currentObj = currentObj;
//    mark.getOffset = function () {
//      var offset = {}
//      var offsetObj = currentObj.getOffset();
//      offset.currentObj = offsetObj;
//      offset.x = offsetObj.x;
//      offset.y = offsetObj.y;
//      return offset;
//    }
//    mark.setOffset = function () {
//      currentObj.setOffset();
//    }
//    mark.getPosition = function () {
//      var poi = {};
//      var poiObj = currentObj.getPosition();
//      poi.currentObj = poiObj;
//      poi.lng = poiObj.lng;
//      poi.lat = poiObj.lat;
//      return poi;
//    }
//    mark.setPosition = function (data) {
//      var lnglat = data.currentObj ? data.currentObj : this.lngLat(lnglat).currentObj;
//      currentObj.setPosition(lnglat)
//    }
//    mark.setIcon = function (str) {
//      currentObj.setIcon(str);
//    }
//    mark.setLabel = function (str) {
//      currentObj.setLabel(str);
//    }
//    //mark.setLabel
//    //mark.getLabel
//    //mark.setIcon
//    //mark.getIcon
//    //mark.getContent
//    //mark.setContent
//    //mark.moveAlong
//    //mark.moveTo
//    //mark.stopMove
//    //mark.pauseMove
//    //mark.resumeMove
//    //mark.setMap
//    //mark.getMap
//    //mark.setTitle
//    //mark.getTitle
//    return mark;
//  },

//  setMarkPosition(data) {
//    var lnglat = data.lnglat.currentObj ? data.lnglat.currentObj : this.lngLat(data.lnglat).currentObj;
//    data.obj.currentObj.setPosition(lnglat);
//  },
//  getMarkPosition(obj) {
//    return { currentObj: obj.currentObj.getPosition() };
//  },
//  getMarkLabel(obj) {
//    return obj.currentObj.getLabel();
//  },
//  setMarkLabel(data) {
//    data.obj.currentObj.setLabel(data.label);
//  },
//  setMarkOffset(data) {
//    data.obj.currentObj.setOffset(data.pixel);
//  },
//  //轨迹展示UI组件
//  pathSimplifierIns(data, callback) {
//    var map = this.getMapObj(data).currentObj;
//    var orginData = [];
//    var _this = this;
//    if (data.data) {
//      for (let i = 0; i < data.data.length; i++) {
//        orginData.push({
//          name: data.data[i].name,
//          path: _this.getPoints(data.data[i].path)
//        })
//      }
//    } else {
//      orginData = [];
//    }
//    var renderOptions = {};
//    if (data.renderOptions) {
//      renderOptions = data.renderOptions;
//    } else {
//      renderOptions = {
//        //轨迹线的样式
//        renderAllPointsIfNumberBelow: 100,
//        pathLineStyle: {
//          strokeStyle: 'red',
//          lineWidth: 6,
//          dirArrowStyle: true
//        }
//      }
//    }
//    AMapUI.load(['ui/misc/PathSimplifier'], function (PathSimplifier) {

//      if (!PathSimplifier.supportCanvas) {
//        alert('当前环境不支持 Canvas！');
//        return;
//      }
//      //启动页面
//      var pathSimplifierIns = new PathSimplifier({
//        zIndex: 100,
//        map: map,
//        data: orginData,
//        autoSetFitView: data.autoSetFitView === undefined ? true : data.autoSetFitView,
//        getPath: function (pathData, pathIndex) {
//          if (data.getPath) {
//            data.getPath(pathData, pathIndex);
//          } else {
//            return pathData.path
//          }
//        },
//        getHoverTitle: function (pathData, pathIndex, pointIndex) {
//          if (data.getHoverTitle) {
//            return data.getHoverTitle(pathData, pathIndex, pointIndex);
//          }
//          else {
//            //返回鼠标悬停时显示的信息
//            if (pointIndex >= 0) {
//              //鼠标悬停在某个轨迹节点上
//              return pathData.name + '，点:' + (pointIndex + 1) + '/' + pathData.path.length;
//            }
//            //鼠标悬停在节点之间的连线上
//            return pathData.name + '，点数量' + pathData.path.length;
//          }
//        },
//        renderOptions: renderOptions,
//        clickToSelectPath: false,//点击轨迹节点或者轨迹节点间的连线时，选中该轨迹，默认true。
//        onTopWhenSelected: false,//置顶选中的轨迹线；置顶的含义是，将该轨迹线的zIndex设置为现存最大值+1。默认true。
//      });
//      var pathObj = {
//        currentObj: pathSimplifierIns,
//        getPathData: function (index) {
//          return pathObj.currentObj.getPathData(index);
//        },
//        createPathNavigator: function (pathIndex, config) {
//          var index = pathIndex ? pathIndex : 0;
//          var nav = pathSimplifierIns.createPathNavigator(index, {
//            loop: config.loop ? config.loop : false,
//            speed: config.speed ? config.speed : 1000,
//            //pathNavigatorStyle: {
//            //  pathLinePassedStyle: {
//            //    lineWidth: 6,
//            //    strokeStyle: '#3CA81B',
//            //    dirArrowStyle: {
//            //      stepSpace: 15,
//            //      strokeStyle: 'red'
//            //    }
//            //  }
//            //}
//          })
//          return {
//            currentObj: nav,
//            start: function (pointIndex) {
//              nav.start(pointIndex);
//            },
//            pause: function () {
//              nav.pause();
//            },
//            resume: function () {
//              nav.resume();
//            },
//            destroy: function () {
//              nav.destroy();
//            },
//            getPosition: function () {
//              var p = nav.getPosition();
//              var position = _this.lngLat(p.lng, p.lat);
//              return position;
//            },
//            setSpeed: function (speed) {
//              nav.setSpeed(speed);
//            },
//            on: function (eventName, handler) {
//              nav.on(eventName, handler);
//            },
//            off: function (eventName, handler) {
//              nav.off(eventName, handler);
//            },
//          }
//        },
//        setData: function (data) {
//          var arr = [];
//          for (let i = 0; i < data.length; i++) {
//            arr.push({
//              name: data[i].name,
//              path: _this.getPoints(data[i].path)
//            })
//          }
//          pathSimplifierIns.setData(data);
//        },
//        on: function (eventName, handel) {
//          pathSimplifierIns.on(eventName, handel);
//        },
//        clearPathNavigators: function () {
//          pathSimplifierIns.clearPathNavigators();
//        },
//        getSelectedPathIndex: function () {
//          return pathSimplifierIns.getSelectedPathIndex();
//        },
//        getSelectedPathData: function () {
//          pathSimplifierIns.getSelectedPathData();
//        },
//        hide: function () {
//          pathSimplifierIns.hide();
//        },
//        show: function () {
//          pathSimplifierIns.show();

//        }
//      };
//      if (callback) {
//        callback(pathObj);
//      }
//    });

//  },
//  //轨迹回放
//  //移动
//  moveAlong(data) {
//    var circlable = data.circlable ? data.circlable : false;
//    //data.obj.moveAlong(data.lineArr, 500);
//    var points = this.getPoints(data.lineArr);
//    data.obj.currentObj.moveAlong(points, data.speed, circlable);
//  },
//  //停止移动
//  stopMove(data) {
//    data.obj.currentObj.stopMove();
//  },
//  //暂停移动
//  pauseMove(data) {
//    data.obj.currentObj.pauseMove();
//  },
//  //继续移动
//  resumeMove(data) {
//    data.obj.currentObj.resumeMove();
//  },
//  //注册地图事件
//  on(data) {
//    var $this = this;
//    data.obj.currentObj.on(data.eventName, (e) => {
//      var obj = {};
//      if (data.eventName == "click") {
//        obj.target = {};
//        obj.target.currentObj = e.target;
//        obj.type = e.type;
//        obj.lnglat = $this.lngLat(e.lnglat.lng, e.lnglat.lat);
//      } else if (data.eventName == "zoomend") {
//        obj.target = {};
//        obj.target.currentObj = e.target;
//      }
//      if (data.callback) {
//        data.callback(obj);
//      }
//    });

//  },
//  //poi搜索
//  search(id, callback) {
//    //加载PoiPicker
//    AMapUI.loadUI(['misc/PoiPicker'], function (PoiPicker) {
//      var auto = new PoiPicker({
//        input: id,//输入框id
//      });
//      auto.on("poiPicked", (res) => {
//        var data = {};
//        data.location = res.item.location;
//        data.adcode = res.item.adcode;
//        data.district = res.item.district;
//        data.address = res.item.address;
//        data.name = res.item.name;
//        if (callback) {
//          callback(data);
//        }
//      })

//    });
//  },

//  //关闭测距
//  closeRangTool(data) {
//    this.rangtool[data.id].turnOff();
//  },

//  //测距
//  openRangTool(data) {
//    this.rangtool[data.id].turnOn();
//    this.rangtool[data.id].on("addnode", (res) => {
//      if (data.addcallback) {
//        data.addcallback(res)
//      }
//    });
//    this.rangtool[data.id].on("removenode", (res) => {
//      if (data.delcallback) {
//        data.delcallback(res)
//      }
//    });
//    this.rangtool[data.id].on("end", (res) => {
//      if (data.endcallback) {
//        data.endcallback(res)
//      }
//    })

//  },

//  //开启鼠标工具
//  openMouseTool(data) {
//    var _this = this;
//    this.mousetool.on("draw", (e) => {
//      let drawData = {
//        radius: 0,
//        points: null,
//        type: data.type,
//        target: e.obj
//      }
//      switch (e.obj.CLASS_NAME) {
//        case "AMap.Circle":
//          drawData.radius = e.obj.getRadius();
//          let position = e.obj.getCenter();
//          drawData.points = {
//            currentObj: position,
//            lng: position.lng,
//            lat: position.lat,

//          };
//          break;
//        case "AMap.Polygon":
//          drawData.points = _this.setPoints(e.obj.getPath());
//          drawData.area = e.obj.getArea();
//          break;
//        case "AMap.Polyline":
//          drawData.points = _this.setPoints(e.obj.getPath());
//          drawData.length = e.obj.getLength();
//      }
//      if (data.callback) {
//        data.callback(drawData);
//      }
//    })

//    //开启鼠标操作
//    switch (data.type) {
//      case 'marker':
//        this.mousetool.marker();
//        break;
//      case 'polyline':
//        this.mousetool.polyline();
//        break;
//      case 'polygon':
//        this.mousetool.polygon();
//        break;
//      case 'rectangle':
//        this.mousetool.rectangle();
//        break;
//      case 'circle':
//        this.mousetool.circle();
//        break;
//      case 'rule':
//        this.mousetool.rule();
//        break;
//      case 'measureArea':
//        this.mousetool.measureArea();
//        break;
//      case 'rectZoomIn':
//        this.mousetool.rectZoomIn();
//        break;
//      case 'rectZoomOut':
//        this.mousetool.rectZoomOut();
//        break;
//    }
//  },

//  //关闭鼠标工具
//  closeMouseTool() {
//    this.mousetool.close();
//  },
//  // 计算两点间的角度
//  calcAngle: function (data, start, end) {
//    let map = this.getMapObj(data).currentObj;
//    let p_start = map.lngLatToContainer(start),
//      p_end = map.lngLatToContainer(end);
//    let diff_x = p_end.x - p_start.x,
//      diff_y = p_end.y - p_start.y;
//    return 360 * Math.atan2(diff_y, diff_x) / (2 * Math.PI) + 90;
//  },
//  //覆盖物
//  overLay: function (data, colorOpt) {
//    if (!colorOpt) colorOpt = {};
//    var map = this.getMapObj(data).currentObj;
//    var shape = null;
//    var $this = this;
//    var obj = {};
//    //绘制作战线路线图
//    if (data.type == "geodesic") {
//      let shapes = [];
//      let shapesAry = [];
//      data.points.forEach((item, index) => {
//        let geoConfig = {
//          map: map,
//          path: item.value,
//          ...data.config
//        };
//        shape = new AMap.Polyline(geoConfig);
//        let shapeObj = {
//          lineName: item.name,
//          shape: shape,
//        }
//        shapes.push(shape);
//        shapesAry.push(shapeObj);
//      })
//      // 缩放地图到合适的视野级别
//      //map.setFitView(shapes);
//      return shapesAry;
//    };
//    var lnglat = this.getPoints(data.points);
//    if (data.type == "circle") {
//      shape = new AMap.Circle({
//        title: data.title ? data.title : "特殊",
//        map: map,
//        center: lnglat[0],  // 圆心位置
//        radius: data.radius, // 圆半径
//        strokeColor: colorOpt.strokeColor ? colorOpt.strokeColor : strokeColor, //线颜色
//        strokeOpacity: colorOpt.strokeOpacity ? colorOpt.strokeOpacity : strokeOpacity, //线透明度
//        strokeWeight: colorOpt.strokeWeight ? colorOpt.strokeWeight : strokeWeight,    //线宽
//        fillColor: colorOpt.fillColor ? colorOpt.fillColor : fillColor, //填充色
//        fillOpacity: colorOpt.fillOpacity ? colorOpt.fillOpacity : fillOpacity//填充透明度
//      });
//      //map.setZoomAndCenter(12, lnglat[0]);
//    }
//    else if (data.type == "ellipse") {
//      shape = new AMap.Ellipse({
//        map: map,
//        center: lntlat[0],  // 圆心位置
//        strokeColor: colorOpt.strokeColor ? colorOpt.strokeColor : strokeColor, //线颜色
//        strokeOpacity: colorOpt.strokeOpacity ? colorOpt.strokeOpacity : strokeOpacity, //线透明度
//        strokeWeight: colorOpt.strokeWeight ? colorOpt.strokeWeight : strokeWeight,    //线宽
//        fillColor: colorOpt.fillColor ? colorOpt.fillColor : fillColor, //填充色
//        fillOpacity: colorOpt.fillOpacity ? colorOpt.fillOpacity : fillOpacity//填充透明度
//      });
//      map.setZoomAndCenter(12, lnglat[0]);
//    }
//    else {
//      var config = {
//        map: map,
//        path: lnglat,
//        strokeColor: colorOpt.strokeColor ? colorOpt.strokeColor : strokeColor, //线颜色
//        strokeOpacity: colorOpt.strokeOpacity ? colorOpt.strokeOpacity : strokeOpacity, //线透明度
//        strokeWeight: colorOpt.strokeWeight ? colorOpt.strokeWeight : strokeWeight,    //线宽
//        fillColor: colorOpt.fillColor ? colorOpt.fillColor : fillColor, //填充色
//        fillOpacity: colorOpt.fillOpacity ? colorOpt.fillOpacity : fillOpacity//填充透明度
//      }
//      //map.setZoomAndCenter(12, lnglat[0]);
//    }

//    if (data.type == "polygon" || data.type == "rectangle") {
//      shape = new AMap.Polygon(config);
//    }
//    else if (data.type == "polyline") {
//      shape = new AMap.Polyline(config);
//      obj.currentObj = shape;
//      obj.getPath = () => {
//        return obj.currentObj.getPath();
//      }
//      obj.setPath = (arr) => {
//        let pathData = [];
//        for (var i = 0; i < arr.length; i++) {
//          if (arr[i].currentObj) {
//            pathData.push(arr[i].currentObj)
//          } else {
//            pathData.push(arr[i]);
//          }
//        }
//        obj.currentObj.setPath(pathData)
//      }
//    }
//    obj.currentObj = shape;

//    return obj;
//  },

//  //绘制线路
//  drawRoute(data) {
//    var amap = this.getMapObj(data).currentObj;
//    if (data.dragroute === undefined) {
//      //路线规划没有传递对象时，默认只有一条数据，操作的都是一条数据
//      var $this = this;
//      var mapData = {};
//      if (this.dragroute) {
//        this.dragroute.destroy();
//      }
//      if (data.path) {
//        if (data.path.length == 0) {
//          path = [];
//          mapData.points = [];
//          mapData.routeObj = null;
//          mapData.start = null;
//          mapData.end = null;
//          mapData.waypoints = [];
//          if (data.completecallback) {
//            data.completecallback(mapData);
//          }
//        }
//      }
//      let copyPath = core.clone(data.path);
//      this.dragroute = new AMap.DragRoute(amap, copyPath, data.type);
//      this.dragroute.search();

//      this.dragroute.on("complete", obj => {
//        mapData.points = mapFunc.getPath(obj.data.start.location, obj.data.waypoints, obj.data.end.location);
//        mapData.routeObj = obj.target;
//        mapData.start = obj.data.start.location;
//        mapData.end = obj.data.end.location;
//        var way = obj.data.waypoints;
//        mapData.waypoints = [];
//        for (var i = 0; i < way.length; i++) {
//          mapData.waypoints.push(way[i].location);
//        }
//        mapData.routesObj = obj.data;
//        mapData.routes = this.dragroute.getRoute();
//        if (data.completecallback) {
//          data.completecallback(mapData);
//        }
//      })
//      this.dragroute.on("addway", function (obj) {
//        if (data.addwaycallback) {
//          data.addwaycallback(obj);
//        }
//      })
//    }
//    else {
//      //参数包括对象时，处理的是参数的路线对象
//    }
//  },
//  //驾车线路规划
//  driving() {
//    let driving = new AMap.Driving({
//      // 驾车路线规划策略，AMap.DrivingPolicy.LEAST_TIME是最快捷模式
//      policy: AMap.DrivingPolicy.LEAST_TIME
//    });
//    let obj = {};
//    obj.currentObj = driving;
//    //使用经纬度获取驾车规划数据
//    obj.search = function (config, callback) {
//      if (!config.opts) {
//        //无途经点
//        config.opts = {
//          waypoints: []
//        };
//      } else if (!config.opts.waypoints) {
//        //无途经点
//        config.opts.waypoints = [];
//      }
//      if (config.startLngLat && config.endLngLat) {
//        //经纬度
//        let startLngLat = config.startLngLat.currentObj ? config.startLngLat.currentObj : config.startLngLat;
//        let endLngLat = config.endLngLat.currentObj ? config.endLngLat.currentObj : config.endLngLat;
//        obj.currentObj.search(startLngLat, endLngLat, config.opts, (status, result) => {
//          //status =>complete error no_data
//          callback(status, result)
//        })
//      } else if (config.points) {
//        //关键字获取驾车规划数据
//        //var points = [
//        //    { keyword: '北京市地震局（公交站）', city: '北京' },
//        //    { keyword: '亦庄文化园（地铁站）', city: '北京' }
//        //]
//        console.log(config.points);
//        obj.currentObj.search(config.points, (status, result) => {
//          //status =>complete error no_data
//          callback(status, result)
//        })
//      }
//    }
//    return obj;
//  },
//  //摧毁路线
//  destroyRoute(data) {
//    if (data.obj) {
//      data.obj.destroy();
//    } else {
//      throw new Error("dstory 的参数不正确");
//    }
//  },
//  //绘制行政区划
//  drawDistrict(data) {
//    var $this = this;
//    var amap = this.getMapObj(data).currentObj;
//    this.district.setLevel = data.level;
//    this.district.search(data.name + "", (status, result) => {
//      if (status == "complete") {
//        var bounds = result.districtList[0].boundaries
//        var polygons = []
//        if (bounds) {
//          for (var i = 0, l = bounds.length; i < l; i++) {
//            //生成行政区划polygon
//            var polygon = new AMap.Polygon({
//              map: amap,
//              path: bounds[i],
//              strokeColor,
//              strokeOpacity,
//              strokeWeight,
//              fillColor,
//              fillOpacity,
//            })
//            polygons.push(polygon)
//          }
//          // 地图自适应
//          amap.setFitView()
//        }
//      } else {
//        throw new Error("数据错误");
//      }
//      if (data.callback) {
//        var shape = {};
//        shape[data.name] = polygons;
//        data.callback(status, result, shape);
//      }
//    });

//  },
//  setClusterMarkers(data) {
//    var amap = this.getMapObj(data).currentObj;
//    data.obj.currentObj.setMarkers(data.datas);
//    //amap.setFitView();
//  },
//  //点聚合
//  markerClusterer(data) {
//    var amap = this.getMapObj(data).currentObj;
//    var $this = this;
//    var points = this.getPoints(data.markers);
//    var cluster = new AMap.MarkerClusterer(amap, data.markers, {
//      gridSize: data.gridSize ? data.gridSize : 60,
//      maxZoom: data.maxZoom ? data.maxZoom : 60,
//      renderClusterMarker: data.renderClusterMarker ? data.renderClusterMarker : null
//    });
//    cluster.on("click", (res) => {
//      if (data.clickcallback) {
//        data.clickcallback(res);
//      }
//    });
//    amap.setFitView();
//    obj = {};
//    obj.currentObj = cluster;
//    obj.setMarkers = function (arr) {

//    }

//    return obj;
//  },
//  //清除地图上的所有信息窗体
//  clearInfoWindow(data) {
//    var amap = this.getMapObj(data).currentObj;
//    amap.clearInfoWindow();
//  },
//  //点聚合添加点（单个）
//  addClusterMarker(data) {
//    data.obj.currentObj.addMarker(data.marker.currentObj);
//    var amap = this.getMapObj(data).currentObj;
//    //amap.setFitView();

//  },
//  //点聚合添加点(批量)
//  addClusterMarkers(data) {
//    data.obj.currentObj.addMarkers(data.markers);
//  },
//  //清除所有点聚合
//  clearClusterMarkers(config) {
//    config.obj.currentObj.clearMarkers();
//  },
//  //移除单个聚合点
//  removeClusterMarker(data) {
//    if (data.obj) {
//      data.obj.currentObj.removeMarker(data.marker.currentObj);
//    } else {
//      throw new Error("removeClusterMarker参数不正确");
//    }
//  },
//  //移除聚合点(批量)
//  removeClusterMarkers(data) {
//    if (data.obj) {
//      data.obj.currentObj.removeMarkers(data.markers);
//    } else {
//      throw new Error("removeClusterMarker参数不正确");
//    }
//  },
//  //获取聚合数量
//  getClustersCount(data) {
//    if (data.obj) {
//      return data.obj.currentObj.getClustersCount();
//    } else {
//      throw new Error("getClustersCount参数不正确");
//    }
//  },
//  //信息窗体
//  infoWindow(data) {
//    let infoWindow = new AMap.InfoWindow({
//      content: data.content ? data.content : "内容为空",
//      offset: data.offset ? data.offset : new AMap.Pixel(20, -20),
//      autoMove: data.autoMove === undefined ? false : data.autoMove,
//      isCustom: data.isCustom === undefined ? false : data.autoMove
//    })
//    infoWindow.on("close", () => {
//      if (data.closecallback) {
//        data.closecallback();
//      }
//    })
//    infoWindow.on("open", () => {
//      if (data.opencallback) {
//        data.opencallback();
//      }
//    })
//    infoWindow.on("change", () => {
//      if (data.changecallback) {
//        data.changecallback();
//      }
//    })
//    let obj = {};
//    obj.currentObj = infoWindow;
//    return obj;
//  },
//  simpleInfoWindow(callback) {
//    //加载SimpleInfoWindow，loadUI的路径参数为模块名中 'ui/' 之后的部分
//    AMapUI.loadUI(['overlay/SimpleInfoWindow'], function (SimpleInfoWindow) {
//      var infoWindow = new SimpleInfoWindow({
//        infoTitle: '<strong>这里是标题</strong>',
//        infoBody: '<p>这里是内容。</p>'
//      });
//      //显示在map上
//      infoWindow.open(map, map.getCenter());
//      var obj = {};
//      obj.currentObj = infoWindow;
//      if (callback) {
//        callback(obj);
//      }
//    });
//  },
//  //打开信息窗体
//  openInfoWindow(data) {
//    let amap = this.getMapObj(data).currentObj;
//    if (data.position.currentObj) {
//      data.obj.currentObj.open(amap, data.position.currentObj);
//    } else if (Array.isArray(data.position)) {
//      let position = new AMap.LngLat(data.position[0], data.position[1], true);
//      data.obj.currentObj.open(amap, position);
//    }
//  },
//  closeInfoWindow(obj) {
//    obj.currentObj.close();
//  },
//  setInfoContent(data) {
//    data.obj.currentObj.setContent(data.content);
//  },
//  getInfoContent(obj) {
//    return obj.currentObj.getContent()
//  },
//  setInfoPosition(data) {
//    var lnglat = data.lnglat.currentObj ? data.lnglat.currentObj : this.lngLat(data.lnglat).currentObj;
//    data.obj.currentObj.setPosition(lnglat);
//  },
//  getInfoPosition(obj) {
//    return { currentObj: obj.currentObj.getPosition() }
//  },
//  //自定义图层对象
//  customLayer(data) {
//    //创建图层对象
//    let amap = this.getMapObj(data).currentObj;
//    var options = data.options ? data.options : {};
//    var customLayer = new AMap.CustomLayer(data.drawObj, {
//      map: options.map ? options.map : amap,
//      zooms: options.zooms ? options.zooms : [3, 20],
//      alwaysRender: options.alwaysRender !== undefined ? options.alwaysRender : true,//缩放过程中是否重绘，复杂绘制建议设为false
//      zIndex: options.zIndex ? options.zIndex : 120
//    });
//    var instance = { currentObj: customLayer };
//    instance.setMap = function (map) {
//      //map对象
//      instance.currentObj.setMap(map);

//    }
//    instance.hide = function () {
//      instance.currentObj.hide();
//    }
//    instance.show = function () {
//      instance.currentObj.show();
//    }
//    instance.setzIndex = function (number) {
//      instance.currentObj.setzIndex(number);
//    }
//    instance.getzIndex = function () {
//      return instance.currentObj.getzIndex();
//    }
//    instance.setOpacity = function (number) {
//      instance.currentObj.setOpacity(number);
//    }
//    instance.setRender = function (fn) {
//      if (typeof fn == "function") {
//        instance.currentObj.render = fn;
//      } else {
//        console.error("参数类型应为 Function");
//      }
//    }
//    return instance;
//  },
//  //轨迹纠偏服务 绑路
//  graspRoad() {
//    let grasp = new AMap.GraspRoad()
//    let obj = {
//      currentObj: grasp,
//    }
//    obj.driving = function (originPath, callback) {
//      if (!error) {
//        var newPath = result.data.points;//纠偏后的轨迹
//        var distance = result.data.distance;//里程
//        callback(newPath, distance);
//      } else {
//        callback(null, null);
//      }
//    }
//    return obj;
//  },
//  //定位对象
//  getGeoLocation(data) {
//    var geolocation = new AMap.Geolocation({
//      enableHighAccuracy: data.enableHighAccuracy ? data.enableHighAccuracy : true,//是否使用高精度定位，默认:true
//      timeout: data.timeout ? data.timeout : 4000,          //超过10秒后停止定位，默认：5s
//      buttonPosition: 'RB',    //定位按钮的停靠位置
//      buttonOffset: new AMap.Pixel(10, 20),//定位按钮与设置的停靠位置的偏移量，默认：Pixel(10, 20)
//      zoomToAccuracy: data.zoomToAccuracy ? data.zoomToAccuracy : true   //定位成功后是否自动调整地图视野到定位点
//    });
//    var obj = {
//      currentObj: geolocation,
//      getCurrentPosition: (callback) => {
//        geolocation.getCurrentPosition(function (status, result) {
//          if (status == 'complete') {
//            var param = {
//              info: "成功",
//              message: "",
//              position: [result.position.lng, result.position.lat],
//            }
//          } else {
//            var param = {
//              info: "失败",
//              message: result.message,
//              position: null
//            }
//          }
//          if (callback) {
//            callback(param)
//          }
//        });
//      }
//    }
//    return obj;
//  },
//  //调整地图视野
//  setFitView(id,data) {
//    var map = this.getMapObj({ id: id }).currentObj;
//    if (data) {
//      var param = data.currentObj ? data.currentObj : data
//      map.setFitView(param);
//    } else {
//      map.setFitView();
//    }
  
//  },
//  getHeatmap(data) {
//    var amap = this.getMapObj(data).currentObj;
//    var obj = {};
//    var heatmap = new AMap.Heatmap(amap, {});
//    obj.currentObj = heatmap;
//    //radius gradient opacity zooms
//    //设置热力图属性
//    obj.setOptions = (option) => {
//      obj.currentObj.setOptions(option);
//    }
//    //设置热力图展现的数据集
//    obj.setDataSet = (dataset) => {

//      obj.currentObj.setDataSet(dataset);
//    }
//    //设置热力图展现的数据集
//    obj.setMap = (data) => {
//      if (data) {
//        data = data.currentObj ? data.currentObj : data;
//      }
//      obj.currentObj.setMap(data);
//    }
//    //
//    obj.show = () => {
//      obj.currentObj.show();
//    }
//    //
//    obj.hide = (dataset) => {
//      obj.currentObj.hide();
//    }
//    return obj;
//  },
//  setObject3DLayer(data) {
//    var amap = this.getMapObj(data).currentObj;
//    var obj = {};
//    var object3Dlayer = new AMap.Object3DLayer();
//    obj.currentObj = object3Dlayer;
//    obj.add = (wall) => {
//      obj.currentObj.add(wall);
//    }
//    amap.add(object3Dlayer);
//    return obj;
//  },
//  setObject3DWall(data) {
//    //data :object3Dlayer
//    var obj = {};
//    var wall = new AMap.Object3D.Wall({
//      path: data.options.bounds,
//      height: data.options.height,
//      color: data.options.color
//    });
//    obj.currentObj = wall;
//    data.object3Dlayer.currentObj.add(obj.currentObj);
//    return obj;
//  },
//  //设置省级图层
//  getDistrictLayerProvince(data) {
//    var obj = {};
//    var disProvince = new AMap.DistrictLayer.Province(data);
//    obj.currentObj = disProvince;
//    obj.setMap = (map) => {
//      if (map.currentObj) {
//        obj.currentObj.setMap(map.currentObj);
//      } else {
//        obj.currentObj.setMap(map);
//      }
//    };
//    return obj;
//  },
//  getDistrictLayerCountry(data) {
//    var obj = {};
//    var disCountry = new AMap.DistrictLayer.Country(data);
//    obj.currentObj = disCountry;
//    obj.setMap = (map) => {
//      if (map.currentObj) {
//        obj.currentObj.setMap(map.currentObj);
//      } else {
//        obj.currentObj.setMap(map);
//      }
//    };
//    return obj;
//},
//  getAMapBounds(southWest, northEast) {
//    southWest = southWest.currentObj ? southWest.currentObj : southWest;
//    northEast = northEast.currentObj ? northEast.currentObj : northEast;
//    var myBounds = new AMap.Bounds(southWest, northEast);
//    var obj = {
//      currentObj: myBounds
//    };
//    obj.contains = function (lnglat) {
//      lnglat=lnglat.currentObj ?lnglat.currentObj : lnglat
//      return obj.currentObj.contains(lnglat);
//    }
//    obj.getCenter = function () {
//      return obj.currentObj.getCenter();
//    }
//    obj.getNorthEast = function () {
//      return obj.currentObj.getNorthEast();
//    }
//    obj.getSouthWest = function () {
//      return obj.currentObj.getSouthWest();
//    }
//    obj.toString = function () {
//      return obj.currentObj.toString();
//    }
//    return obj;
//  },

//}
//export default obj;
