//对path进行处理，得到最新的path
let obj = {
  getPath: function (startP, wayP, endP) {
    var path = [];
    path.push([startP.lng.toFixed(6), startP.lat.toFixed(6)]);
    for (let i = 0; i < wayP.length; i++) {
      path.push([wayP[i].location.lng.toFixed(6), wayP[i].location.lat.toFixed(6)]);
    }
    if ((endP.lng != startP.lng) && (endP.lat!= startP.lat)) {
      path.push([endP.lng.toFixed(6), endP.lat.toFixed(6)]);
    }
    return path; 
  },
  /**
 * @desc 数组深度拷贝，返回新数组
 * @param {Arrys} source 
 * @returns {Arrys}
 */
  deepCopy: function (source) {
    try {
      var str = JSON.stringify(source);
      return JSON.parse(str);
    }
    catch(err){
      throw new Error(err);
    }
  
  },

  
}
export default obj;
